Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class SingletonItem<T extends Item>

    java.lang.Object
      net.sf.saxon.value.Value<T>
          net.sf.saxon.value.SingletonItem<T>

All Implemented Interfaces:
  GroundedValue<T>, ValueRepresentation<T>

    public class SingletonItem<T extends Item>

extends Value<T>
implements GroundedValue<T>

A value that is a sequence containing zero or one items. Used only for items that are not atomic values (that is, nodes, and function items)

Field Summary
`protected T` | `item`

Fields inherited from class net.sf.saxon.value.Value
`INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`SingletonItem(T item)` Create a node-set containing zero or one nodes

Method Summary
`T` | `asItem()` Return the value in the form of an Item
`boolean` | `effectiveBooleanValue()` Get the effective boolean value
`int` | `getCardinality()` Determine the static cardinality
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the items in the expression.
`int` | `getLength()` Get the length of the sequence
`String` | `getStringValue()` Convert the value to a string, using the serialization rules.
`T` | `itemAt(int n)` Get the n'th item in the sequence (starting from 0).
`SequenceIterator<T>` | `iterate()` Return an enumeration of this nodeset value.
`void` | `process(XPathContext context)` Process the instruction, without returning any tail calls
`GroundedValue<T>` | `subsequence(int start, int length)` Get a subsequence of the value

Methods inherited from class net.sf.saxon.value.Value
`asItem, asIterator, asValue, checkPermittedContents, convertToJava, equals, fromItem, getCanonicalLexicalRepresentation, getIterator, getSchemaComparable, getSequenceLength, getStringValueCS, hashCode, isIdentical, reduce`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.om.ValueRepresentation
`getStringValueCS`

Field Detail

### item

    protected T extends Item item

Constructor Detail

### SingletonItem

    public SingletonItem(T item)

  Create a node-set containing zero or one nodes

  Parameters:
    `item` - The node or function-item to be contained in the node-set, or null if the sequence is to be empty

Method Detail

### asItem

    public T asItem()

  Return the value in the form of an Item

  Overrides:
    `asItem` in class `Value<T extends Item>`
  Returns:
    the value in the form of an Item

### process

    public void process(XPathContext context)
                 throws XPathException

  Process the instruction, without returning any tail calls

  Overrides:
    `process` in class `Value<T extends Item>`
  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
  Throws:
    `XPathException` - if an error occurs (for example if the value is a closure that needs to be evaluated)

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items in the expression. This method determines the most precise type that it can, because it is called when testing that the node conforms to a required type.

  Overrides:
    `getItemType` in class `Value<T extends Item>`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the most precise possible type of the node.

### getCardinality

    public int getCardinality()

  Determine the static cardinality

  Overrides:
    `getCardinality` in class `Value<T extends Item>`
  Returns:
    the cardinality

### getLength

    public int getLength()

  Get the length of the sequence

  Specified by:
    `getLength` in interface `GroundedValue<T extends Item>`
  Overrides:
    `getLength` in class `Value<T extends Item>`
  Returns:
    the number of items in the sequence

### itemAt

    public T itemAt(int n)

  Get the n'th item in the sequence (starting from 0). This is defined for all SequenceValues, but its real benefits come for a SequenceValue stored extensionally (or for a MemoClosure, once all the values have been read)

  Specified by:
    `itemAt` in interface `GroundedValue<T extends Item>`
  Overrides:
    `itemAt` in class `Value<T extends Item>`
  Parameters:
    `n` - position of the required item, counting from zero.
  Returns:
    the n'th item in the sequence, where the first item in the sequence is numbered zero. If n is negative or >= the length of the sequence, returns null.

### subsequence

    public GroundedValue<T> subsequence(int start,
                                        int length)

  Get a subsequence of the value

  Specified by:
    `subsequence` in interface `GroundedValue<T extends Item>`
  Parameters:
    `start` - the index of the first item to be included in the result, counting from zero. A negative value is taken as zero. If the value is beyond the end of the sequence, an empty sequence is returned
    `length` - the number of items to be included in the result. Specify Integer.MAX_VALUE to get the subsequence up to the end of the base sequence. If the value is negative, an empty sequence is returned. If the value goes off the end of the sequence, the result returns items up to the end of the sequence
  Returns:
    the required subsequence. If min is

### iterate

    public SequenceIterator<T> iterate()

  Return an enumeration of this nodeset value.

  Specified by:
    `iterate` in class `Value<T extends Item>`
  Returns:
    an iterator over the sequence of items

### effectiveBooleanValue

    public boolean effectiveBooleanValue()

  Get the effective boolean value

  Overrides:
    `effectiveBooleanValue` in class `Value<T extends Item>`
  Returns:
    the effective boolean value

### getStringValue

    public String getStringValue()

  Convert the value to a string, using the serialization rules. For atomic values this is the same as a cast; for sequence values it gives a space-separated list. For QNames and NOTATIONS, or lists containing them, it fails.

  Specified by:
    `getStringValue` in interface `ValueRepresentation<T extends Item>`
  Overrides:
    `getStringValue` in class `Value<T extends Item>`
  Returns:
    the result of converting the value to a string

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.